package ru.dbotthepony.mc.otm.container;

import net.minecraft.world.Container;
import net.minecraft.world.item.ItemStack;

import java.util.Iterator;
import java.util.function.Consumer;

public class ContainerIteratorItemStack implements java.util.Iterator<ItemStack>, Iterable<ItemStack> {
	private final Container container;
	private int index = 0;
	private ItemStack next_stack;

	public ContainerIteratorItemStack(Container container) {
		this.container = container;
	}

	@Override
	public boolean hasNext() {
		if (index >= container.getContainerSize() && next_stack == null)
			return false;

		if (next_stack == null) {
			while (next_stack == null && index < container.getContainerSize()) {
				ItemStack get = container.getItem(index);

				if (!get.isEmpty()) {
					next_stack = get;
				}

				index++;
			}
		}

		return next_stack != null;
	}

	@Override
	public ItemStack next() {
		ItemStack _next_stack = next_stack;
		next_stack = null;
		return _next_stack;
	}

	@Override
	public Iterator<ItemStack> iterator() {
		return this;
	}

	public void consume(Consumer<ItemStack> consumer) {
		for (ItemStack t : this) {
			consumer.accept(t);
		}
	}
}
