package ru.dbotthepony.mc.otm.network;

import net.minecraft.network.FriendlyByteBuf;
import net.minecraft.server.level.ServerPlayer;
import net.minecraftforge.api.distmarker.Dist;
import net.minecraftforge.fml.DistExecutor;
import net.minecraftforge.fmllegacy.network.NetworkEvent;
import ru.dbotthepony.mc.otm.matter.MatterRegistry;
import ru.dbotthepony.mc.otm.menu.MatterBottlerMenu;

import java.util.function.Supplier;

public record MatterBottlerSwitchPacket() {
	public void write(FriendlyByteBuf buffer) {

	}

	public static MatterBottlerSwitchPacket read(FriendlyByteBuf buffer) {
		return new MatterBottlerSwitchPacket();
	}

	public void playServer(ServerPlayer ply) {
		if (ply.containerMenu instanceof MatterBottlerMenu menu) {
			menu.switchBottlerMode();
		}
	}

	public void play(Supplier<NetworkEvent.Context> context) {
		context.get().setPacketHandled(true);
		context.get().enqueueWork(() -> playServer(context.get().getSender()));
	}
}
