package ru.dbotthepony.mc.otm.screen;

import net.minecraft.network.chat.Component;
import net.minecraft.network.chat.TranslatableComponent;
import net.minecraft.world.entity.player.Inventory;
import ru.dbotthepony.mc.otm.menu.MatterBottlerMenu;
import ru.dbotthepony.mc.otm.menu.slot.BatterySlot;
import ru.dbotthepony.mc.otm.menu.widget.GaugeWidget;
import ru.dbotthepony.mc.otm.screen.panels.*;

import javax.annotation.Nullable;
import java.util.List;

public class MatterBottlerScreen extends MatteryScreen<MatterBottlerMenu> implements MatteryScreen.IMatteryScreenGaugeGetter, MatteryScreen.IMatteryScreenBatteryGetter, MatteryScreen.IMatteryScreenGridBased {
	public MatterBottlerScreen(MatterBottlerMenu menu, Inventory inventory, Component title) {
		super(menu, inventory, title);
	}

	@Override
	public List<GaugeWidget> getGauges() {
		return List.of(menu.battery_widget, menu.matter_widget);
	}

	@Override
	public List<BatterySlot> getBatterySlots() {
		return List.of(menu.battery_slot);
	}

	@Override
	public void createGridPanels(FlexGridPanel grid) {
		new SlotPanel<>(this, grid, menu.work_slots[0]);
		new SlotPanel<>(this, grid, menu.work_slots[1]);
		new SlotPanel<>(this, grid, menu.work_slots[2]);
		new MatteryWidgetPanel(this, grid, menu.progress).setDockMargin(2, 0, 2, 0);
		new SlotPanel<>(this, grid, menu.work_slots[3]);
		new SlotPanel<>(this, grid, menu.work_slots[4]);
		new SlotPanel<>(this, grid, menu.work_slots[5]);
	}

	@Nullable
	@Override
	protected FramePanel makeMainFrame() {
		var frame = super.makeMainFrame();

		var mode = new ButtonPanel(this, frame, 0, 0, 100, 20, new TranslatableComponent("otm.matter_bottler.switch_mode"));
		mode.bindOnPress(menu::switchBottlerMode);
		mode.setDock(Dock.TOP);
		mode.asGrid(); // for auto alignment on center

		return frame;
	}
}
